; ==============================================================================
; file: "source/system/kernel/math.inc"
; use: to be included in "source/system/kernel.asm"
; TODO: comments and descriptions
; ==============================================================================

math_int_to_hex:

; --------------------------------------------------
; description: converts int dword to hex string
; input: dword [number_1] = input number
;        dword [string_1] = address of output string
; output: {none}
; altered: {none}
; --------------------------------------------------

    .prepare:
        pusha                           ; registers are preserved
        mov cl, 28                      ; we save the address of output string
        mov esi, dword [string_1]
    
    .save_digit:
        mov eax, dword [number_1]       ; we save 4 bits corresponding
        shr eax, cl                     ; to current digit
        and eax, 0x0F
    
    .check_0_9:
        cmp eax, 9                      ; if those bits symbolize a number (0-9)
        jbe .save_0_9                   ; then we check the number area
    
    .save_A_F:
        add eax, 55                     ; else we check the capital letter area
        jmp .continue                   ; capital letters start at 55+10
    
    .save_0_9:
        add eax, 48                     ; numbers start at 48+0
        
    .continue:
        mov word [esi], ax              ; result is saved and we go
        add esi, 2                      ; to next char and next 4 bits
        cmp cl, 0                       ; except we have reached 32 bits
        je .return                      ; in this situation we return
        sub cl, 4
        jmp .save_digit
    
    .return:
        mov word [esi], 0               ; output string is null terminated
        popa                            ; registers are restored
        ret
