; ==============================================================================
; file: "source/system/kernel/string.inc"
; use: to be included in "source/system/kernel.asm"
; ==============================================================================

string_compare:

; -----------------------------------------------------
; description: compares two strings
; input: dword [string_1] = address of first string
;        dword [string_2] = address of second string
; output: equality flag (set if equal, clear if differ)
; altered: {none}
; -----------------------------------------------------

    .prepare:
        pusha                           ; registers are preserved
        mov esi, dword [string_1]       ; we get string 1 address
        mov edi, dword [string_2]       ; we get string 2 address
    
    .get_chars:
        mov ax, word [esi]              ; we get char from string 1
        mov bx, word [edi]              ; we get char from string 2
    
    .compare:
        cmp ax, bx                      ; if chars not equal, strings not equal
        jne .return
        cmp ax, 0                       ; if chars null, strings ended equal
        je .return
    
    .go_to_next:
        add esi, 2                      ; we go to next ucs-2 chars
        add edi, 2                      ; to compare them
        jmp .get_chars
    
    .return:
        popa                            ; registers are restored
        ret
